#ifdef GL_ES
precision highp float;
#endif

attribute vec4 a_position;
attribute vec4 a_normals;

uniform mat4 u_worldView;
uniform float delta;
uniform float u_distanceFraction;
uniform float u_ratio;
uniform float u_offsetX;

uniform vec3 eye;
uniform vec3 light;

varying float ndot;
varying vec2 v_tex_coords;
varying vec3 v_refractedRay;

void main()
{
	vec3 v_position = a_position.xyz;
	v_tex_coords.x = (u_offsetX + ((a_position.x + 1.0) / 2.0 - u_offsetX) / (u_ratio * ((2.0 - u_ratio) + (u_ratio - 1.0) * u_distanceFraction)));
	v_tex_coords.y = a_position.y * 0.5 + 0.5;
	v_tex_coords = vec2(v_tex_coords.x, 1.0 - v_tex_coords.y);

	vec3 ll = vec3(-1.0 * delta, 0.0, a_normals.r);
	vec3 lu = vec3(0.0, delta, a_normals.g);
	vec3 lr = vec3(delta, 0.0, a_normals.b);
	vec3 lb = vec3(0.0, -1.0 * delta, a_normals.a);
	
	//vec3 v_normal = normalize(cross(lu, ll) + cross(lr, lu) + cross(lb, lr) + cross(ll, lb));
	vec3 v_normal = normalize(cross(lu, ll) + cross(lb, lr));
	vec3 v_incommingRay = normalize(v_position - eye);
	v_refractedRay = normalize(refract(v_incommingRay, v_normal, 1.0 / 1.333));
	
	vec3 v_reflectedRay = normalize(reflect(light, v_normal));
	ndot = pow(max(0.0, dot(v_incommingRay, v_reflectedRay)), 4.0);

	float y_range = u_distanceFraction*(u_ratio-1.0) + (2.0-u_ratio);
	gl_Position =  u_worldView * a_position * vec4(1.0, y_range, 1.0, 1.0);
}